'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * A list of all PIPs shipped with WSC and their default file names.
 *
 * @see {@link https://github.com/WoltLab/WCF/tree/master/wcfsetup/install/files/lib/system/package/plugin}
 */
var DEFAULT_PIP_FILENAMES = {
    aclOption: 'aclOption.xml',
    acpMenu: 'acpMenu.xml',
    acpSearchProvider: 'acpSearchProvider.xml',
    acpTemplate: 'acptemplates.tar',
    bbcode: 'bbcode.xml',
    box: 'box.xml',
    clipboard: 'clipboard.xml',
    coreObject: 'coreObject.xml',
    cronjob: 'cronjob.xml',
    eventListener: 'eventListener.xml',
    file: 'files.tar',
    language: 'language/*.xml',
    menu: 'menu.xml',
    menuitem: 'menuitem.xml',
    objectType: 'objectType.xml',
    objectTypeDefinition: 'objectTypeDefinition.xml',
    option: 'option.xml',
    page: 'page.xml',
    pip: 'packageInstallationPlugin.xml',
    script: null,
    smiley: 'smiley.xml',
    sql: 'install.sql',
    style: null,
    template: 'templates.tar',
    templateListener: 'templateListener.xml',
    userGroupOption: 'userGroupOption.xml',
    userOption: 'userOption.xml',
    userProfileMenu: 'userProfileMenu.xml',
    userNotificationEvent: 'userNotificationEvent.xml'
};

var PipParser = function () {
    function PipParser(additionalPips) {
        _classCallCheck(this, PipParser);

        this.additionalPips = additionalPips;
    }

    _createClass(PipParser, [{
        key: 'run',
        value: function run(instructions) {
            var _this = this;

            var pips = this.getPipList();

            return instructions.map(function (it) {
                return _this.getFileName(it, pips);
            });
        }
    }, {
        key: 'getPipList',
        value: function getPipList() {
            var that = this;

            var pipList = DEFAULT_PIP_FILENAMES;
            for (var pip in this.additionalPips) {
                pipList[pip] = that.additionalPips[pip];
            }

            return pipList;
        }
    }, {
        key: 'getFileName',
        value: function getFileName(instruction, pips) {
            if (instruction.path) {
                return instruction.path;
            }

            if (pips[instruction.type]) {
                return pips[instruction.type];
            }

            throw new Error('No default filename was provided for the PIP "' + instruction.type + '"');
        }
    }]);

    return PipParser;
}();

exports.default = PipParser;