'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _async = require('async');

var _async2 = _interopRequireDefault(_async);

var _Packager = require('./Packager');

var _Packager2 = _interopRequireDefault(_Packager);

var _PackageXmlParser = require('./PackageXmlParser');

var _PackageXmlParser2 = _interopRequireDefault(_PackageXmlParser);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TaskRunner = function () {
    function TaskRunner(options) {
        _classCallCheck(this, TaskRunner);

        this.options = options;
        this.xml = null;
    }

    _createClass(TaskRunner, [{
        key: 'run',
        value: function run() {
            var that = this;

            // Run the following instructions in series.
            _async2.default.series([function (cb) {
                return that.doesPackageXmlExist(cb);
            }, function (cb) {
                return that.readAndParseFile(cb);
            }, function (cb) {
                return that.runPackager(cb);
            }], this.done);
        }
    }, {
        key: 'done',
        value: function done(err, results) {
            // If any of the functions threw an error, exit here.
            if (err) {
                return console.log(err);
            }
        }
    }, {
        key: 'doesPackageXmlExist',
        value: function doesPackageXmlExist(callback) {
            _fs2.default.stat('package.xml', function (err, stats) {
                if (err) {
                    return callback(new Error("The package.xml could not be accessed in this folder."));
                }

                callback(null, true);
            });
        }
    }, {
        key: 'readAndParseFile',
        value: function readAndParseFile(callback) {
            var parser = new _PackageXmlParser2.default();
            parser.parse(this, callback);
        }
    }, {
        key: 'runPackager',
        value: function runPackager(callback) {
            var packager = new _Packager2.default(this.filesToPackage, this.xmlInfo);
            packager.run(callback, this.options.quiet);
        }
    }]);

    return TaskRunner;
}();

exports.default = TaskRunner;